#import "BWThingie.h"


@implementation BWThingie

+ (NSDateFormatter *) dateFormatter {

// With 20,000 thingies, slow takes about 5 seconds,
#define SLOW 0

#if SLOW
    NSDateFormatter *formatter = [[NSDateFormatter alloc] init];

    formatter.dateStyle = NSDateFormatterShortStyle;
    formatter.timeStyle = NSDateFormatterShortStyle;

    return formatter;

#else
    static NSDateFormatter *s_formatter;
    if (s_formatter == nil) {
        s_formatter = [[NSDateFormatter alloc] init];

        s_formatter.dateStyle = NSDateFormatterShortStyle;
        s_formatter.timeStyle = NSDateFormatterShortStyle;
    }
    return s_formatter;
#endif

} // dateFormatter


+ (BWThingie *) thingieWithString: (NSString *) string {
    NSArray *split = [string componentsSeparatedByString: @"\t"];

    if (split.count != 5) return nil;
    
    BWThingie *thingie = [[self alloc] init];
    thingie.device = split[0];
    thingie.someValue = split[1];
    thingie.status = split[3];
    thingie.responsible = split[4];
    
    NSDateFormatter *formatter = [self dateFormatter];

    NSString *timestampString = split[2];
    NSDate *ook = [formatter dateFromString: timestampString];

    thingie.timestamp = ook;

    return thingie;

} // thingieWithString


- (NSString *) description {
    NSString *desc = [NSString stringWithFormat: @"<%@ %p : %@ %@ %@ %@ %@>",
                               self.class, self, self.device, self.someValue,
                               self.timestamp, self.status, self.responsible];
    return desc;
} // description


@end // BWThingie
