#import <Foundation/Foundation.h>

// clang -arch i386 -g  -o makedata makedata.m

#define randomchar ((char)('a' + random() % 26))
#define randomnum (random() % 10)

static void device (char *buffer) {
    snprintf (buffer, 1024, "%c%c%d%d%d",
              randomchar, randomchar,
              randomnum, randomnum, randomnum);
} // device


static void somevalue (char *buffer) {
    snprintf (buffer, 1024, "%c%c%c%d%d%d%c%c",
              randomchar, randomchar, randomchar,
              randomnum, randomnum, randomnum,
              randomchar,randomchar);
} // somevalue


static void timestamp (char *buffer) {
    snprintf (buffer, 1024, "%d/%d/%d %d:%02d %s",
              (random() % 12) + 1,
              (random() % 28) + 1,
              (random() % 6) + 8,
              (random() % 12) + 1,
              (random() % 60) + 1,
              random() % 1 ? "AM" : "PM");
} // timestamp


static void status (char *buffer) {
    char *status = "";
    switch (random() % 10) {
    case 0: status = "engaged"; break;
    case 1: status = "operational"; break;
    case 2: status = "proper"; break;
    case 3: status = "encabulated"; break;
    case 4: status = "offline"; break;
    case 5: status = "disengaged"; break;
    case 6: status = "glorped"; break;
    case 7: status = "snorgled"; break;
    case 8: status = "flarn"; break;
    case 9: status = "blorfed"; break;
    }
    snprintf (buffer, 1024, "%s", status);
} // status


static responsible (char *buffer) {
    char *responsible = "";
    switch (random() % 10) {
    case 0: responsible = "JWhorfin"; break;
    case 1: responsible = "JBigboote"; break;
    case 2: responsible = "JSmallberries"; break;
    case 3: responsible = "JVink"; break;
    case 4: responsible = "JYaya"; break;
    case 5: responsible = "JGrant"; break;
    case 6: responsible = "JO'Connor"; break;
    case 7: responsible = "JParker"; break;
    case 8: responsible = "JEmdall"; break;
    case 9: responsible = "JValuk"; break;
    }
    snprintf (buffer, 1024, "%s", responsible);
} // responsible


int main (int argc, const char *argv[]) {

    if (argc != 2) {
        printf ("usage: %s count\n", argv[0]);
        return -1;
    }
    srandom(time(NULL));
    int count = atoi (argv[1]);

    char deviceB[1024];
    char somevalueB[1024];
    char timestampB[1024];
    char statusB[1024];
    char responsibleB[1024];

    for (int i = 0; i < count; i++) {
        device (deviceB);
        somevalue (somevalueB);
        timestamp (timestampB);
        status (statusB);
        responsible (responsibleB);
        printf ("%s\t%s\t%s\t%s\t%s\n",
                deviceB, somevalueB, timestampB, statusB, responsibleB);
    }

    return 0;

} // main

